Skip to content

# nlohmann::basic_json::to_msgpack

    // (1)
    static std::vector<std::uint8_t> to_msgpack(const basic_json& j);

    // (2)
    static void to_msgpack(const basic_json& j, detail::output_adapter<std::uint8_t> o);
    static void to_msgpack(const basic_json& j, detail::output_adapter<char> o);

Serializes a given JSON value `j` to a byte vector using the MessagePack serialization format. MessagePack is a binary serialization format which aims to be more compact than JSON itself, yet more efficient to parse.

1. Returns a byte vector containing the MessagePack serialization.
2. Writes the MessagePack serialization to an output adapter.

The exact mapping and its limitations is described on a dedicated page.

## Parameters

`j` (in)
  JSON value to serialize
`o` (in)
  output adapter to write serialization to

## Return value

1. MessagePack serialization as byte vector
2. (none)

## Exception safety

Strong guarantee: if an exception is thrown, there are no changes in the JSON value.

## Complexity

Linear in the size of the JSON value `j`.

## Examples

Example

The example shows the serialization of a JSON value to a byte vector in MessagePack format.

    #include <iostream>
    #include <iomanip>
    #include <nlohmann/json.hpp>

    using json = nlohmann::json;
    using namespace nlohmann::literals;

    int main()
    {
        // create a JSON value
        json j = R"({"compact": true, "schema": 0})"_json;

        // serialize it to MessagePack
        std::vector<std::uint8_t> v = json::to_msgpack(j);

        // print the vector content
        for (auto& byte : v)
        {
            std::cout << "0x" << std::hex << std::setw(2) << std::setfill('0') << (int)byte << " ";
        }
        std::cout << std::endl;
    }

Output:

    0x82 0xa7 0x63 0x6f 0x6d 0x70 0x61 0x63 0x74 0xc3 0xa6 0x73 0x63 0x68 0x65 0x6d 0x61 0x00

## Version history

- Added in version 2.0.9.

Last update: May 1, 2022
Back to top